// Copyright (C) 2007 CEREA
//     Author(s): Meryem Ahmed de Biasi
//
// CEREA (http://www.enpc.fr/cerea/) is a joint laboratory of ENPC
// (http://www.enpc.fr/) and EDF R&D (http://www.edf.fr/).
//
// This file is part of the air quality modeling system Polyphemus.
//
// Polyphemus is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// Polyphemus is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
// more details.
//
// For more information, please see the Polyphemus web site:
//     http://www.enpc.fr/cerea/polyphemus/

#ifndef COMMON_FILE_COMMON_HXX

#include <cmath>
#include <cstring>
#include <iostream>
#include <vector>
using namespace std;

#include "Talos.hxx"
using namespace Talos;

#include "AtmoData.hxx"
using namespace AtmoData;

namespace Polyphemus
{
  void parse_argument(int argc, char** argv, string& config_file,
		      string default_name = "");
  void parse_argument(int argc, char** argv, string& first_file,
		      string& second_file, string default_name = "");
  void parse_argument(int argc, char** argv, string& first_file,
		      string& second_file, Date& date,
		      string default_name = "");
  void parse_argument(int argc, char** argv, string& first_file,
		      string& second_file, Date& date_beg, Date& date_end,
		      string default_name = "");
  
  Date read_date_MM5(string FileName);

  Date convert_delta(string delta, Date date_beg);

   template <class T>
  int compute_Nt(Date date_beg, Date date_end, T Delta_t);
 
} //namespace Polyphemus

#define COMMON_FILE_COMMON_HXX
#endif
